Index: /trunk/hlpmgr/globalfilelist.h
===================================================================
--- /trunk/hlpmgr/globalfilelist.h	(revision 359)
+++ /trunk/hlpmgr/globalfilelist.h	(revision 360)
@@ -13,5 +13,5 @@
 typedef TOpenFileEntry* TPOpenFileEntry;
 
-typedef struct 
+typedef struct
 {
   TSubAllocatedSharedMemory FMem;
@@ -24,6 +24,6 @@
 void CloseGlobalFilelist( TGlobalFilelist* pList );
 
-HWND FindFileInGlobalFilelist( TGlobalFilelist* pList,
-                               char* FilePath );
+HWND FindFileInGlobalFilelist( TGlobalFilelist* pList, char* FilePath );
 
 #endif
+
Index: /trunk/hlpmgr/helpinstance.c
===================================================================
--- /trunk/hlpmgr/helpinstance.c	(revision 359)
+++ /trunk/hlpmgr/helpinstance.c	(revision 360)
@@ -17,5 +17,5 @@
   if ( ! pHelpInstance -> FViewerStarted )
   {
-    // get focus frame 
+    // get focus frame
     FocusFrame = GetTopLevelWindow( WinQueryFocus( HWND_DESKTOP ) );
     // associate viewer with that.
@@ -77,5 +77,5 @@
                    mp2 );
   if ( ok )
-    LogEvent( "  Posted OK" ); 
+    LogEvent( "  Posted OK" );
   else
     LogEvent( "  WinPostMsg failed" );
@@ -86,5 +86,5 @@
 //--------------------------------------------------------------------------------
 void PostQueuedViewerMessages( TPHelpInstance pHelpInstance )
-{  
+{
   int i;
   TQueuedViewerMessage ViewerMessage;
@@ -119,5 +119,5 @@
 //--------------------------------------------------------------------------------
 
-// Add the given window to the list of associated 
+// Add the given window to the list of associated
 // windows for this help instance
 //--------------------------------------------------------------------------------
@@ -129,6 +129,6 @@
             pHelpInstance );
 
-  if ( IsWindowAssociated( pHelpInstance, hwnd ) ) 
-  { 
+  if ( IsWindowAssociated( pHelpInstance, hwnd ) )
+  {
     LogEvent( "Already associated" );
     return;
@@ -151,5 +151,5 @@
 
   // see if it will fit.
-  if (    pHelpInstance -> FNumApplicationWindows 
+  if (    pHelpInstance -> FNumApplicationWindows
        >= pHelpInstance -> FMaxApplicationWindows )
   {
@@ -160,5 +160,5 @@
     else
       // double space
-      pHelpInstance -> FMaxApplicationWindows *= 2; 
+      pHelpInstance -> FMaxApplicationWindows *= 2;
 
     LogEvent( "AssociateWIndow: allocating list space to %d",
@@ -166,10 +166,10 @@
 
     // reallocate memory.
-    pHelpInstance -> FApplicationWindows 
-      = (HWND*) realloc( pHelpInstance -> FApplicationWindows, 
-                         pHelpInstance -> FMaxApplicationWindows 
+    pHelpInstance -> FApplicationWindows
+      = (HWND*) realloc( pHelpInstance -> FApplicationWindows,
+                         pHelpInstance -> FMaxApplicationWindows
                          * sizeof( HWND ) );
   }
-  
+
   pHelpInstance ->
     FApplicationWindows[ pHelpInstance -> FNumApplicationWindows ]
@@ -180,7 +180,7 @@
   LogEvent( "AssociateWindow: Now have %d windows associated",
             pHelpInstance -> FNumApplicationWindows );
-}  
-
-// Removes the given window from the list of associated 
+}
+
+// Removes the given window from the list of associated
 // windows for this help instance (if present)
 //--------------------------------------------------------------------------------
@@ -199,5 +199,5 @@
       j = i;
       while( j < pHelpInstance -> FNumApplicationWindows - 1 )
-      { 
+      {
         pHelpInstance -> FApplicationWindows[ j ]
           = pHelpInstance -> FApplicationWindows[ j + 1 ];
@@ -245,5 +245,5 @@
   ulMagicNumber = WinQueryWindowULong( hwnd, QWL_HELPINSTANCEMAGICNUMBER );
 
-  if ( ulMagicNumber != HELPINSTANCEMAGICNUMBER ) 
+  if ( ulMagicNumber != HELPINSTANCEMAGICNUMBER )
     return NULL;
 
@@ -263,5 +263,5 @@
     // free copy of resource
     FreeHelpTable( & ( pHelpInstance -> pHelpTable ) );
-}   
+}
 
 //--------------------------------------------------------------------------------
@@ -276,9 +276,9 @@
   pHelpInstance -> FNumApplicationWindows = 0;
   pHelpInstance -> FMaxApplicationWindows = 0;
-  pHelpInstance -> FApplicationWindows = NULL; 
-    
-  pHelpInstance -> FActiveWindow = NULLHANDLE; 
+  pHelpInstance -> FApplicationWindows = NULL;
+
+  pHelpInstance -> FActiveWindow = NULLHANDLE;
 
   return pHelpInstance;
 }
-
+
Index: /trunk/hlpmgr/misc.c
===================================================================
--- /trunk/hlpmgr/misc.c	(revision 359)
+++ /trunk/hlpmgr/misc.c	(revision 360)
@@ -5,6 +5,6 @@
 #include "misc.h"
 
-USHORT APIENTRY NHMSearchMIndex( PVOID pInstance, 
-                                 HWND hwnd, 
+USHORT APIENTRY NHMSearchMIndex( PVOID pInstance,
+                                 HWND hwnd,
                                  PSZ pchText )
 {
@@ -13,5 +13,5 @@
 }
 
-// e.g.   p = DBMstrtok2(EnvStr, "; \0");    
+// e.g.   p = DBMstrtok2(EnvStr, "; \0");
 // probably just use strtok unless you really want to support dbcs
 PCH APIENTRY NHMDBMstrtok2( PCH s1, PCH s2 )
@@ -28,8 +28,8 @@
 }
 
-// e.g. 
-// pCountry = (PVOID)WinSendMsg ( _hwndMIndexInstance, 
-//                                HM_QPSTRUCT,  
-//                                MPFROMSHORT(STRUCT_COUNTRY_INFO), 
+// e.g.
+// pCountry = (PVOID)WinSendMsg ( _hwndMIndexInstance,
+//                                HM_QPSTRUCT,
+//                                MPFROMSHORT(STRUCT_COUNTRY_INFO),
 //                                NULL );
 // if ( MscStriCmp( TabText.pString, szBuf1, pCountry ) )
@@ -44,5 +44,5 @@
 
 // Attempt to see if we can get OpenChat running (not with help tho)
-BOOL APIENTRY NHM32SetHelpDatabase(PINSTANCE pInstance, PSZ DatabaseName, USHORT usObtimizeType) 
+BOOL APIENTRY NHM32SetHelpDatabase(PINSTANCE pInstance, PSZ DatabaseName, USHORT usObtimizeType)
 {
   // Jolly good, whatever you say...
@@ -71,3 +71,3 @@
   return TRUE;
 }
-
+
Index: /trunk/hlpmgr/sharedmemory.c
===================================================================
--- /trunk/hlpmgr/sharedmemory.c	(revision 359)
+++ /trunk/hlpmgr/sharedmemory.c	(revision 360)
@@ -17,5 +17,5 @@
   char FullName[ 260 ];
 
-  pSharedMemory -> FFirst = TRUE;  
+  pSharedMemory -> FFirst = TRUE;
 
   strcpy( FullName, "\\SHAREMEM\\" );
@@ -31,5 +31,5 @@
   {
     LogEvent( "  Unable to create shared mem: %d", rc );
-    if ( rc == ERROR_ALREADY_EXISTS ) 
+    if ( rc == ERROR_ALREADY_EXISTS )
     {
       LogEvent( "  - Already exists, open" );
@@ -55,6 +55,6 @@
   while( TRUE )
   {
-    rc = DosOpenMutexSem( pszName, 
-                          phmtx ); 
+    rc = DosOpenMutexSem( pszName,
+                          phmtx );
 
     if ( rc != ERROR_SEM_NOT_FOUND )
@@ -62,8 +62,8 @@
       break;
 
-    rc = DosCreateMutexSem( pszName, 
+    rc = DosCreateMutexSem( pszName,
                             phmtx,
-                            0, 
-                            FALSE ); 
+                            0,
+                            FALSE );
     if ( rc != ERROR_DUPLICATE_NAME )
       // ok, or some error
@@ -91,5 +91,5 @@
                                     ULONG Size,
                                     ULONG ReserveSize, // size to reserve at start of memory
-                                    TSubAllocatedSharedMemory* pSharedMemory ) 
+                                    TSubAllocatedSharedMemory* pSharedMemory )
 {
   APIRET rc;
@@ -113,5 +113,5 @@
   LogEvent( "  semaphore name: %s", SemaphoreName );
 
-  rc = OpenOrCreateMutex( SemaphoreName, 
+  rc = OpenOrCreateMutex( SemaphoreName,
                           & StartupSemaphore );
   if ( rc != 0 )
@@ -151,5 +151,5 @@
   }
 
-  pSharedMemory -> FAllocationArea = 
+  pSharedMemory -> FAllocationArea =
     (PBYTE) pSharedMemory -> FMem.FPointer
     + ActualReserveSize;
@@ -207,5 +207,5 @@
                     void** p )
 {
-  APIRET rc;  
+  APIRET rc;
   PULONG pSize;
   ULONG Size;
@@ -221,5 +221,5 @@
 
   *p = NULL;
-}    
+}
 
 void ReleaseSubAllocatedSharedMemory( TSubAllocatedSharedMemory* pSharedMemory )
@@ -232,3 +232,3 @@
   ReleaseSharedMemory( & pSharedMemory -> FMem );
 }
-
+
Index: /trunk/hlpmgr/sharedmemory.h
===================================================================
--- /trunk/hlpmgr/sharedmemory.h	(revision 359)
+++ /trunk/hlpmgr/sharedmemory.h	(revision 360)
@@ -7,5 +7,5 @@
 // in the memory.
 
-typedef struct 
+typedef struct
 {
   void* FPointer;
@@ -25,8 +25,8 @@
 // Otherwise the Data property should not be used.
 
-typedef struct 
+typedef struct
 {
   TSharedMemory FMem;
-  void* FAllocationArea;  
+  void* FAllocationArea;
 } TSubAllocatedSharedMemory;
 
@@ -34,5 +34,5 @@
                                     ULONG Size,
                                     ULONG ReserveSize, // size to reserve at start of memory
-                                    TSubAllocatedSharedMemory* pSharedMemory ); 
+                                    TSubAllocatedSharedMemory* pSharedMemory );
 
 // suballocate space of the given size
@@ -51,2 +51,3 @@
 
 #endif
+
Index: /trunk/hlpmgr/utility.c
===================================================================
--- /trunk/hlpmgr/utility.c	(revision 359)
+++ /trunk/hlpmgr/utility.c	(revision 360)
@@ -1,3 +1,3 @@
-#include <stdlib.h> 
+#include <stdlib.h>
 #include <string.h>
 
@@ -8,5 +8,5 @@
 {
   ULONG buffer;
-  DosQuerySysInfo( QSV_BOOT_DRIVE, 
+  DosQuerySysInfo( QSV_BOOT_DRIVE,
                    QSV_BOOT_DRIVE,
                    & buffer,
@@ -40,10 +40,10 @@
   while( TRUE )
   {
-    parent = WinQueryWindow( hwnd, QW_PARENT );    
+    parent = WinQueryWindow( hwnd, QW_PARENT );
     if (    parent == hDesktopWindow
          || parent == NULLHANDLE )
       // this is a frame (top level) window
       break;
-    hwnd = parent; 
+    hwnd = parent;
   }
 
@@ -61,5 +61,5 @@
   LogEvent( "IsStandardWindowClass" );
 
-  if ( WinQueryClassName( hwnd, 
+  if ( WinQueryClassName( hwnd,
                           sizeof( szClassName ),
                           szClassName ) == 0 )
@@ -87,11 +87,11 @@
                   char* source )
 {
-  if ( *dest != NULL )  
+  if ( *dest != NULL )
   {
     free( *dest );
     *dest = NULL;
   }
-  
-  if ( source == NULL )  
+
+  if ( source == NULL )
     return;
 
@@ -99,3 +99,3 @@
   strcpy( *dest, source );
 }
-
+
Index: /trunk/hlpmgr/utility.h
===================================================================
--- /trunk/hlpmgr/utility.h	(revision 359)
+++ /trunk/hlpmgr/utility.h	(revision 360)
@@ -32,5 +32,5 @@
 BOOL IsStandardWindowClass( HWND hwnd, PSZ ClassID );
 
-// make a memory copy of the given source string into 
+// make a memory copy of the given source string into
 // dest. Accepts NULLs for either parameter.
 void StoreString( char** dest,
@@ -38,2 +38,3 @@
 
 #endif
+