Index: trunk/src/emx/include/386/stdarg.h
===================================================================
--- trunk/src/emx/include/386/stdarg.h	(revision 366)
+++ trunk/src/emx/include/386/stdarg.h	(revision 366)
@@ -0,0 +1,89 @@
+/*-
+ * Copyright (c) 2002 David E. O'Brien.  All rights reserved.
+ * Copyright (c) 1991, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *	This product includes software developed by the University of
+ *	California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *	@(#)stdarg.h	8.1 (Berkeley) 6/10/93
+ * $FreeBSD: src/sys/i386/include/stdarg.h,v 1.18 2002/11/27 16:28:18 obrien Exp $
+ *
+ * @@level      FreeBSD 5.1
+ * @@changed    bird: _VA_LIST
+ */
+
+#ifndef _MACHINE_STDARG_H_
+#define	_MACHINE_STDARG_H_
+
+#include <sys/cdefs.h>
+#include <sys/_types.h>
+
+#ifndef _VA_LIST_DECLARED
+#define	_VA_LIST_DECLARED
+#define _VA_LIST                        /* bird: emx */
+typedef	__va_list	va_list;
+#endif
+
+#if defined(__GNUC__) && (__GNUC__ == 2 && __GNUC_MINOR__ > 95 || __GNUC__ >= 3)
+
+#define	va_start(ap, last) \
+	__builtin_stdarg_start((ap), (last))
+
+#define	va_arg(ap, type) \
+	__builtin_va_arg((ap), type)
+
+#if __ISO_C_VISIBLE >= 1999
+#define	va_copy(dest, src) \
+	__builtin_va_copy((dest), (src))
+#endif
+
+#define	va_end(ap) \
+	__builtin_va_end(ap)
+
+#else	/* ! __GNUC__ post GCC 2.95 */
+
+#define	__va_size(type) \
+	(((sizeof(type) + sizeof(int) - 1) / sizeof(int)) * sizeof(int))
+
+#ifdef __GNUC__
+#define va_start(ap, last) \
+	((ap) = (va_list)__builtin_next_arg(last))
+#else	/* non-GNU compiler */
+#define	va_start(ap, last) \
+	((ap) = (va_list)&(last) + __va_size(last))
+#endif	/* __GNUC__ */
+
+#define	va_arg(ap, type) \
+	(*(type *)((ap) += __va_size(type), (ap) - __va_size(type)))
+
+#define	va_end(ap)
+
+#endif /* __GNUC__ post GCC 2.95 */
+
+#endif /* !_MACHINE_STDARG_H_ */
Index: trunk/src/emx/include/machine/stdarg.h
===================================================================
--- trunk/src/emx/include/machine/stdarg.h	(revision 366)
+++ trunk/src/emx/include/machine/stdarg.h	(revision 366)
@@ -0,0 +1,2 @@
+/* symlink */
+#include <386/stdarg.h>
Index: trunk/src/emx/include/stdarg.h
===================================================================
--- trunk/src/emx/include/stdarg.h	(revision 364)
+++ trunk/src/emx/include/stdarg.h	(revision 366)
@@ -1,25 +1,2 @@
-/* stdarg.h (emx+gcc) */
-
-#ifndef _STDARG_H
-#define _STDARG_H
-
-#if !defined (_VA_LIST)
-#define _VA_LIST
-typedef char *va_list;
-#endif
-
-#define _VA_ROUND(t) ((sizeof (t) + 3) & -4)
-
-#if !defined (va_start)
-#define va_start(ap,v) ap = (va_list)&v + ((sizeof (v) + 3) & -4)
-#define va_end(ap) (ap = 0, (void)0)
-#define __std_va_arg(ap,t) (ap += _VA_ROUND (t), *(t *)(ap - _VA_ROUND (t)))
-#endif
-
-#ifdef __BOUNDS_CHECKING_ON
-#include <fix-args.h>
-#else
-#define va_arg(ap,t) __std_va_arg(ap,t)
-#endif
-
-#endif /* not _STDARG_H */
+/* symlink */
+#include <machine/stdarg.h>